#include<stdio.h>
#include<limits.h>
#include<stdlib.h>

main(){
	
	int n,m,ukupnaSreca=0,maxDruzeljubivost = INT_MIN,maxPoznanici = INT_MIN,maxRedniBroj;
	
	scanf("%d",&n);
	scanf("%d",&m);
	
	int ucenici[n],parovi[m][2],brojPoznanika[n],prijatelj[n] = {0},neprijatelj[n] = {0},redniBrojDr[2][n];
	int brojNeprijatelja = 0;
	int brojPrijatelja = 0;
	
	for(int i=0;i<n;i++){
		scanf("%d",&ucenici[i]);
	}
	
	for(int j=0;j<2;j++){
		for(int p=0;p<m;p++){
			scanf("%d",&parovi[j][p]);
		}
		
	}
	
	for(int i=0;i<n;i++){
		redniBrojDr[0][i] = i+1;
		redniBrojDr[1][i] = ucenici[i];
		
	}
	
	for(int k=0;k<n;k++){
		brojPoznanika[k]=0;		
			for(int l=0;l<m;l++){
				for(int z=0;z<2;z++){
					if(k+1==parovi[l][z])
					   brojPoznanika[k]++;
			}
		}
	}
	
	
	for(int k=0;k<n;k++){
		if(abs(brojPoznanika[k])>maxPoznanici){
			maxPoznanici = brojPoznanika[k];   
		}  
    }
	for(int k=0;k<n;k++){
		if(abs(ucenici[k])>maxDruzeljubivost){
			maxDruzeljubivost = ucenici[k];
	    }
	    
	}
	
	for(int k=0;k<n;k++){
	    if(abs(ucenici[k]) == maxDruzeljubivost){
	    	if(brojPoznanika[k] == maxPoznanici){
	    		maxDruzeljubivost = ucenici[k];
			}
		}
	}
	
    for(int k=0;k<n;k++){			
			if(redniBrojDr[1][k] == maxDruzeljubivost && brojPoznanika[k]==maxPoznanici){
				maxRedniBroj = redniBrojDr[0][k];
			}			
		}
	
		for(int i=0;i<m;i++){
	  	    for(int j=0;j<2;j++){
	  	    	if(maxRedniBroj == parovi[i][j] && maxDruzeljubivost<0){
	  	    		if(i==0){
	  	    		    neprijatelj[brojNeprijatelja]=maxRedniBroj;
	  	    		    brojNeprijatelja++;
	  	    		    
					}	  	    			  	    			  	    		
		    	    if(j==0){
		    		   	neprijatelj[brojNeprijatelja] = parovi[i][j+1];
		    		   	brojNeprijatelja++;
					}
					if(j==1){
		    		   	neprijatelj[brojNeprijatelja] = parovi[i][j-1];
		    		   	brojNeprijatelja++;
					}
				    
			   }
			    if(maxRedniBroj == parovi[i][j] && maxDruzeljubivost>0){
	  	    		if(i==0){
	  	    		    prijatelj[brojPrijatelja]=maxRedniBroj;
	  	    		    brojPrijatelja++;
	  	    		    
					}	  	    			  	    		
		    		if(j==0){
		    		   	prijatelj[brojPrijatelja] = parovi[i][j+1];
		    		   	brojPrijatelja++;
					}
					if(j==1){
		    		    prijatelj[brojPrijatelja] = parovi[i][j-1];
		    	 	    brojPrijatelja++;
					}				    		    	    		    				    				    						
			    }
		    }
	    }	
	
	if(brojPrijatelja != 0){
		for(int k=0;k<brojPrijatelja;k++){
		
		ukupnaSreca += ucenici[k]*(brojPoznanika[k]);
		
	}
}
	
	if(brojNeprijatelja != 0){
		for(int j=0;j<brojNeprijatelja;j++){
		
		ukupnaSreca += ucenici[j]*(-brojPoznanika[j]); 
	}
}		
	printf("%d",ukupnaSreca);	
	
}